Program Domino;
 { Clasele 10-12 }
type Piesa=record
             a, b : 0..6;
           end;
     MultimePiese=record
                    k : integer;
                    p : array[1..28] of Piesa;
                  end;
     Tren=MultimePiese;
var n : integer;
    C : MultimePiese;
    X, Xmax : Tren;

procedure Citeste(var C : MultimePiese; var n : integer);
 { Citirea datelor din fisierul de intrare }
var i : integer;
    Intrare : text;
begin
   assign(Intrare, 'DOMINO.IN');
   reset(Intrare);
   readln(Intrare, n);
   C.k:=n;
   for i:=1 to n do
      readln(Intrare, C.p[i].a, C.p[i].b);
   close(Intrare);
end; { Citeste }

procedure Scrie(X : Tren);
 { Scrierea datelor in fisierul de iesire }
var i : integer;
    Iesire : text;
begin
   assign(Iesire, 'DOMINO.OUT');
   rewrite(Iesire);
   writeln(Iesire, X.k);
   for i:=1 to X.k do
     writeln(Iesire, X.p[i].a, ' ', X.p[i].b);
   close(Iesire);
end; { Scrie }

procedure AdaugaVagonul(var X : Tren; Q : Piesa);
 { Adauga vagonul Q la trenul X }
begin
   X.k:=X.k+1;
   X.p[X.k]:=Q;
end;

procedure ScoateVagonul(var X : Tren);
 { Scoate din trenul X ultimul vagon }
begin
  X.k:=X.k-1;
end; { ScoateVagonul}


procedure ExcludePiesa(var Z : MultimePiese; i : integer);
 { Exclude din multimea Z piesa i }
var j : integer;
begin
   for j:=i to Z.k-1 do
     Z.p[j]:=Z.p[j+1];
   Z.k:=Z.k-1;
end; { ExcludePiesa }

function Corespunde(X : MultimePiese; var Q : Piesa) : boolean;
 { Returneaza TRUE daca vagonul Q poate fi atasat la trenul X }
 { In caz de necesitate, roteste piesa Q }
label 1;
var i : integer;
begin
  if X.k=0 then
    begin
      Corespunde:=true;
      goto 1;
    end; { if }
  Corespunde:=false;
  { pozitia initiala a placii Q }
  if X.p[X.k].b=Q.a then
     begin
        Corespunde:=true;
        goto 1;
     end;
  if X.p[X.k].b=Q.b then
     { rotim placa Q }
     begin
        Corespunde:=true;
        i:=Q.a;
        Q.a:=Q.b;
        Q.b:=i;
     end;
1: end; { Corespunde }

procedure Reluare(C : MultimePiese; var X : Tren);
var C1 : MultimePiese;
    Q : Piesa;
    i : integer;
begin
  for i:=1 to C.k do
    begin
      Q:=C.p[i];
      if Corespunde(X, Q) then
         begin
           AdaugaVagonul(X, Q);
           if X.k>Xmax.k then Xmax:=X;
           C1:=C;
           ExcludePiesa(C1, i);
           Reluare(C1, X);
           ScoateVagonul(X);
         end; { if }
    end; { for }
end; { Reluare }

procedure TrenMaxim(C : MultimePiese; X :Tren);
 { Cauta trenul de lungime maxima }
var i, j : integer;
    Xmax : Tren;
begin
  Xmax.k:=0;
  X.k:=0;
  Reluare(C, X);
  { rotim piesele cu care poate incepe trenul }
  for i:=1 to C.k do
   begin
     j:=C.p[i].b; C.p[i].b:=C.p[i].a; C.p[i].a:=j;
   end;
   X.k:=0;
   Reluare(C, X);
end; { Tren }

begin
   Citeste(C, n);
   TrenMaxim(C, X);
   Scrie(Xmax);
end.
